package com.logicbig.example;

import org.springframework.boot.web.server.ErrorPage;
import org.springframework.boot.web.server.ErrorPageRegistrar;
import org.springframework.boot.web.server.ErrorPageRegistry;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Component;

@Component
public class MyErrorPageRegistrar implements ErrorPageRegistrar {

    @Override
    public void registerErrorPages(ErrorPageRegistry registry) {
        registry.addErrorPages(
                createNotFoundErrorPage(),
                createRuntimeExceptionPage(),
                createOtherErrorPage());
    }

    private ErrorPage createNotFoundErrorPage() {
        return new ErrorPage(HttpStatus.NOT_FOUND, "/notFoundServlet");
    }

    private ErrorPage createRuntimeExceptionPage() {
        return new ErrorPage(RuntimeException.class, "/runtimeExceptionHandler");
    }

    private ErrorPage createOtherErrorPage() {
        return new ErrorPage(Throwable.class, "/WEB-INF/internal-error.jsp");
    }
}